module Smooster
  module Deploy
    module MediaAssets

      def collection
        collection = []
        response.each do |file|
          media_asset = MediaAsset.new({:file_path => file, :checksum => Digest::MD5.hexdigest(File.read(file))})
          media_asset.smo_id = media_asset.load_smo_id if media_asset.load_smo_id.present?
          collection << media_asset
        end
        collection
      end
      alias_method :all, :collection

      def response
        @response ||= initialize_collection
      end

      def reload!
        @response = initialize_collection
      end

      def upload_all
        self.all.each do |media_asset|
          media_asset.upload
        end
      end

      def method_missing(name, *args, &block)
        if collection.respond_to? name
          collection.send(name, *args)
        else
          super
        end
      end

      private
        def initialize_collection
          Dir.glob("#{Smooster::Application.instance.base_dir}/#{Smooster::Application.instance.html_folder()}/media/**/*.*")
        end
    end
  end
end


