module Smooster
  module Deploy
    class Setting
      include ActiveModel::Model
      include ActiveModel::Serializers::JSON

      attr_accessor  :images, :formatblock, :rss

      def self.read_config
        if File.exists?("#{Smooster::Application.instance.base_dir}/site_config.yml")
          YAML.load(File.read("#{Smooster::Application.instance.base_dir}/site_config.yml"))
        end
      end

      def self.upload
        begin
          response = RestClient.post "#{Smooster::Application.instance.api_url()}/#{Smooster::Application.instance.site_id()}/configure", {:configs => self.read_config}, {"Authorization" => 'Token token="'+ Smooster::Application.instance.api_key() +'"', "Accept" => 'application/vnd.smoosterid.v2'}
          data = JSON.parse(response)
        rescue => e
          Smooster::Application.instance.logger.error "Error settings!: #{e} / #{e.backtrace.inspect}"
          puts "The settings failed to be updated".colorize(:red)
        end

      end
    end
  end
end
